Subject: [bug#67686] [PATCH core-updates 4/5] gnu: glibc: Install C.UTF-8 locale.

From: Janneke Nieuwenhuizen <[email-masked]>
Date: Thu, 07 Dec 2023 21:31:14 +0100

Ludovic Courtès writes:

Hello!

> Ludovic Courtès <[email-masked]> skribis:
>
>> +                     ;; Install the C.UTF-8 locale so there's always a UTF-8
>> +                     ;; locale around.
>> +                     (let* ((out (assoc-ref outputs "out"))
>> +                            (bin (string-append out "/bin"))
>> +                            (locale (string-append out "/lib/locale/"
>> +                                                   ,(package-version
>> +                                                     this-package))))
>> +                       (mkdir-p locale)
>> +                       (invoke (string-append bin "/localedef")
>> +                               "--no-archive" "--prefix" locale
>> +                               "-i" "C" "-f" "UTF-8"
>> +                               (string-append locale "/C.UTF-8")))))
>
> I realize now that this cannot work when cross-compiling, because the
> this ‘localedef’ binary is not executable on the build machine.
>
> I suspect libc builds an additional ‘localedef’ for the build machine
> but I’m not sure where it is, hmm…

So far, I haven't encountered this problem yet.

Trying to create a hurd image with this patch set, but mpfr fails for
me.

--8<---------------cut here---------------start------------->8---
======================================
   MPFR 4.2.0: tests/test-suite.log
======================================

# TOTAL: 197
# PASS:  196
# SKIP:  0
# XFAIL: 0
# FAIL:  1
# XPASS: 0
# ERROR: 0

.. contents:: :depth: 2

FAIL: tsprintf
==============

Error in mpfr_vsprintf (s, "%0+ -'13.10Pd:", ...);
expected: "+01,234,567  :"
got:      "+0001,234,567:"
FAIL tsprintf (exit status: 1)
--8<---------------cut here---------------end--------------->8---

Updating to 4.2.1 (see attached patch) seems to fix it for me.

Greetings,
Janneke

>From e8b5a6c064b0395ca84749987c97dd9e1172b9ab Mon Sep 17 00:00:00 2001
Message-ID: <[email-masked]>
From: Janneke Nieuwenhuizen <[email-masked]>
Date: Thu, 7 Dec 2023 21:28:24 +0100
Subject: [PATCH] gnu: mpfr: Update to 4.2.1.

This fixes building mpfr with glibc-2.38.

* gnu/packages/multiprecision.scm (mpfr): Update to 4.2.1.

Change-Id: Ib8a8eecc9e72587e0fc1b8b0ee965aa274b85c7b
---
 gnu/packages/multiprecision.scm | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/gnu/packages/multiprecision.scm b/gnu/packages/multiprecision.scm
index 3aa5dccfab..3d11523a07 100644
--- a/gnu/packages/multiprecision.scm
+++ b/gnu/packages/multiprecision.scm
@@ -120,13 +120,13 @@ (define-public gmp-6.0
 (define-public mpfr
   (package
    (name "mpfr")
-   (version "4.2.0")
+   (version "4.2.1")
    (source (origin
             (method url-fetch)
             (uri (string-append "mirror://gnu/mpfr/mpfr-" version
                                 ".tar.xz"))
             (sha256 (base32
-                     "14yr4sf4mys64nzbgnd997l6l4n8l9vsjnnvnb0lh4jh2ggpi8q6"))))
+                     "1cnb3y7y351qg6r7ynwsgaykm7l2a8zg2nlljs4rf9k778shfy17"))))
    (arguments
     (list
      #:phases (if (system-hurd?)

base-commit: 36a126b0580a2d3e01704db7bbe4c3c0da8356d3
-- 
2.41.0

-- 
Janneke Nieuwenhuizen <[email-masked]>  | GNU LilyPond https://LilyPond.org
Freelance IT https://www.JoyOfSource.com | Avatar® https://AvatarAcademy.com